// PrimeNumberDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PrimeNumber.h"
#include "PrimeNumberDlg.h"
#include <math.h>
#include <algorithm>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPrimeNumberDlg dialog



CPrimeNumberDlg::CPrimeNumberDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrimeNumberDlg::IDD, pParent)
	, m_nMax(100)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPrimeNumberDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_MAX_ED, m_nMax);
	DDV_MinMaxInt(pDX, m_nMax, 1, 500000);
}

BEGIN_MESSAGE_MAP(CPrimeNumberDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
END_MESSAGE_MAP()


// CPrimeNumberDlg message handlers

BOOL CPrimeNumberDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPrimeNumberDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPrimeNumberDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPrimeNumberDlg::OnBnClickedButton1()
{
	UpdateData(TRUE);

	InitPrimes(m_nMax*2);

	int nPairCnt = 0;

	int i=1;
	int j=2;
	int sum = 0;

	while( (i<m_nMax) && (j<=m_nMax) )
	{
		sum = i + j;
		//if(IsPrime(sum))
		if(Easy(sum))
		{
			// TRACE("%d + %d = \t\t PRIME %d\n", i,j,sum);
			nPairCnt++;
			i = j + 1;
			j = i + 1;
		}
		else
		{
			// TRACE("%d + %d = %d\n", i,j,sum);
			j++;
		}
	}
	TRACE1("Pairs: %d\n", nPairCnt++);
}

BOOL CPrimeNumberDlg::IsPrime(int nVal)
{
	if(m_lstPrimes.size()>0)
	{
		return (BOOL)(std::find(m_lstPrimes.begin(), m_lstPrimes.end(), nVal) != m_lstPrimes.end());
	}
	return FALSE;
}

int CPrimeNumberDlg::InitPrimes(int nMax)
{
	m_lstPrimes.clear();

	int limit = nMax;
	int sqr_lim;
	bool *is_prime = new bool[nMax+1];
	int x2, y2;
	int i, j;
	int n;

	sqr_lim = (int)sqrt((long double)limit);
	for (i = 0; i <= limit; i++) is_prime[i] = false;
	is_prime[2] = true;
	is_prime[3] = true;

	x2 = 0;
	for (i = 1; i <= sqr_lim; i++) {
		x2 += 2 * i - 1;
		y2 = 0;
		for (j = 1; j <= sqr_lim; j++) {
			y2 += 2 * j - 1;

			n = 4 * x2 + y2;
			if ((n <= limit) && (n % 12 == 1 || n % 12 == 5))
				is_prime[n] = !is_prime[n];

			// n = 3 * x2 + y2; 
			n -= x2;
			if ((n <= limit) && (n % 12 == 7))
				is_prime[n] = !is_prime[n];

			// n = 3 * x2 - y2;
			n -= 2 * y2;
			if ((i > j) && (n <= limit) && (n % 12 == 11))
				is_prime[n] = !is_prime[n];
		}
	}

	for (i = 5; i <= sqr_lim; i++) {
		if (is_prime[i]) {
			n = i * i;
			for (j = n; j <= limit; j += n) {
				is_prime[j] = false;
			}
		}
	}

	for (i = limit; i >=2; i--)
	{
		if (is_prime[i])
		{
			m_lstPrimes.push_back(i);
		}
	}

	delete [] is_prime;

	return m_lstPrimes.size();
}

BOOL CPrimeNumberDlg::Easy(long n)
{
	for(long i=2; i<=(int)(sqrt((double)n)); i++)
	{
		if((n%i)==0)
		{
			return FALSE;
		}
	}
	return TRUE;
}

long CPrimeNumberDlg::FindEasy(long n)
{
	for(long i=n+1; i<=999999; i++)
	{
		if(Easy(i))
		{
			return i;
		}
	}
	return 0;
}

void CPrimeNumberDlg::OnBnClickedButton2()
{
	UpdateData(TRUE);

	int nPairCnt = 0;

	int n = m_nMax;

	if(Easy(n))
	{
		for(long i=n-1; i>=(n+1)/2; i--)
		{
			//TRACE("%d\t%d\n", i, n-i);
			nPairCnt++;
		}
	}
	else
	{
		long m = 0;
		while(n>0)
		{
			m = FindEasy(n);
			if( (m==0) || (m>=2*n) )
			{
				break;
			}

			for(long i = m- n; i<=m/2; i++)
			{
				//TRACE("%d\t%d\n", i, m-i);
				nPairCnt++;
			}
			n = m - n - 1;
		}
	}

	TRACE1("Pairs: %d\n", nPairCnt);
}
